module ExternalQuery where

import Embedding
import HXML
import MyParser
import Variables
import Compute
import ExtendQuery

evalExternalQuery::String->String->String->([(String,String)],[([String],String)],[String])->String->Int->Tree XMLNode->Int->Tree XMLNode
evalExternalQuery filter defaultSearchType text cond t nesting pattern n = case t of
	"P" -> let (res,vars,_) = manageExtQuery filter defaultSearchType indexEL indexTX map tree 2 pattern
	       in buildQueryResult (mangeVarsAndConds filter tree cond nesting res vars 1) filter 1 nesting n
	"N" -> let (res,vars,_) = manageExtQuery "neg" "E" indexEL indexTX map tree 2 pattern
	       in buildQueryResult (mangeVarsAndConds filter tree cond nesting res vars 0) "neg" 0 nesting n
	where
	(indexEL,indexTX,map,tree) = parseText text

evalSimpleQuery::String->String->Index->Index->MPtL Int->Tree XMLNode->Int->Tree XMLNode->([Pos],[Var],Int)
evalSimpleQuery filter searchT indexEL indexTX mapping text pre pattern = case filter of
	"bestEx"
		|(null resPos3) -> ([],vars3,b3)
		|otherwise -> (resPos3,vars3,b3)
	"allEx"
		|(null resPos2) -> ([],vars2,b2)
		|otherwise -> (resPos2,vars2,b2)
	"neg"
		|(null resPos1) -> ([],vars1,b1)
		|otherwise -> (resPos1,vars1,b1)
	otherwise
		|l -> ([],vars,b)
		|not l -> (resPos,vars,b)
	where
	(nTree3,qMap3,vars3,_,b3) = visitQuery pattern pre
	resPos3 = evaluateQuery nTree3 qMap3 [] [] (show pre) indexEL indexTX mapping infinito [] "best" "E"
	-- l3 = length resPos3
	(nTree2,qMap2,vars2,_,b2) = visitQuery pattern pre
	resPos2 = evaluateQuery nTree2 qMap2 [] [] (show pre) indexEL indexTX mapping infinito [] "all" "E"
	-- l2 = length resPos2
	(nTree1,qMap1,vars1,_,b1) = visitQuery pattern pre
	resPos1 = evaluateQuery nTree1 qMap1 [] [] (show pre) indexEL indexTX mapping delcost [] "all" "E"
	-- l1 = length resPos1
	(nTree,qMap,sdc,vars,sType,b) = extendQuery pattern pre
	resPos = evaluateQuery nTree qMap sdc [] (show pre) indexEL indexTX mapping delcost sType filter searchT
	l = null resPos

buildQueryResult::[Pos]->String->Int->Int->Int->Tree XMLNode
buildQueryResult [] _ _ _ _ = (Tree (ELNode "Empty Result" []) [])
buildQueryResult list filter posNeg nesting n
	|(n >= 0) = countEmbedding list n
	|(posNeg == 1) && ((filter == "allEx") || (filter == "bestEx"))= buildUniqueTree list 2
	|posNeg == 1 = buildUniqueTree list nesting
	|posNeg == 0 = (Tree (ELNode "0000" []) [text])
	where
	[(_,_,_,_,_,text)] = list

countEmbedding::[Pos]->Int->Tree XMLNode
countEmbedding [] _ = (Tree (ELNode "Empty Result" []) [])
countEmbedding list cost = (Tree (ELNode "0000" [("Embedding Num",(show num))]) [])
	where
	num = countAux list cost 0
	
countAux [] _ n = n
countAux (p:ps) cost n
	|c <= cost = countAux ps cost (n+1)
	|otherwise = countAux ps cost n
	where
	(pre,d,b,r,c,tree) = p

-- aggiunge una radice di nome result agli embedding (se ce ne sono) altrimenti restituisce un albero "vuoto"
buildUniqueTree::[Pos]->Int->Tree XMLNode
buildUniqueTree [] _ = (Tree (ELNode "Empty Result" []) [])
buildUniqueTree list i
	|(i==2) && (null res) = (Tree (ELNode "Empty Result" []) [])
	|otherwise = (Tree (ELNode "0000" []) res)
	where
	res = exctractTree i list
	
-- estrae gli embedding dai posting e aggiunge un nodo per il rank dell'embedding
exctractTree i [] = []
exctractTree i (p:ps)
	|i==1 = (Tree (ELNode "Query Rank" [("rank",(show c))]) []):((adjust_attributes tree):(exctractTree i ps))
	|i==0 = (adjust_attributes tree):(exctractTree i ps)
	|(i==2) && (c==0) = (adjust_attributes tree):(exctractTree i ps)
	|(i==2) = exctractTree i ps
	where
	(pre,d,b,r,c,tree) = p

manageExtQuery::String->String->Index->Index->MPtL Int->Tree XMLNode->Int->Tree XMLNode->([Pos],[Var],Int)
manageExtQuery filt defType indexEL indexTX mapping tree pre pattern = case pattern of
	(Tree (ELNode "and" []) (arg1:args)) -> manageANDSons filt (manageExtQuery filt defType indexEL indexTX mapping tree) (manageExtQuery filt defType indexEL indexTX mapping tree pre arg1) args
	(Tree (ELNode "or" []) (arg1:args)) -> manageOrSons "or" filt (manageExtQuery filt defType indexEL indexTX mapping tree) (manageExtQuery filt defType indexEL indexTX mapping tree pre arg1) args
	(Tree (ELNode "xor" []) (arg1:args)) -> manageOrSons "xor" filt (manageExtQuery filt defType indexEL indexTX mapping tree) (manageExtQuery filt defType indexEL indexTX mapping tree pre arg1) args
	(Tree (ELNode label atts) args) -> evalSimpleQuery filt defType indexEL indexTX mapping tree pre pattern
	(Tree (TXNode label) []) -> evalSimpleQuery filt defType indexEL indexTX mapping tree pre pattern

manageANDSons _ _ son1 [] = son1
manageANDSons filt func son1 (a:as) 
	| ((filt == "all") || (filt == "neg") || (filt == "allEx")) = manageANDSons filt func ((compute_ExtSum_all pos pos1),vars++vars1,bound1) as
	| otherwise = manageANDSons filt func ((compute_ExtSum_best pos pos1),vars++vars1,bound1) as
	where
	(pos,vars,bound) = son1
	(pos1,vars1,bound1) = func (bound+1) a

manageOrSons _ _ _ son1 [] = son1
manageOrSons "or" filt func son1 (a:as) 
	| ((filt == "all") || (filt == "neg") || (filt == "allEx")) = manageOrSons "or" filt func ((compute_ExtMin_all pos pos1),vars++vars1,bound1) as
	| otherwise = manageOrSons "or" filt func ((compute_ExtMin_best pos pos1),vars++vars1,bound1) as
	where
	(pos,vars,bound) = son1
	(pos1,vars1,bound1) = func (bound+1) a
	
manageOrSons "xor" filt func son1 (a:as)
	| ((filt == "all") || (filt == "neg") || (filt == "allEx")) = manageOrSons "xor" filt func ((compute_Extxor_all pos pos1),vars++vars1,bound1) as
	| otherwise = manageOrSons "xor" filt func ((compute_Extxor_best pos pos1),vars++vars1,bound1) as
	where
	(pos,vars,bound) = son1
	(pos1,vars1,bound1) = func (bound+1) a

mangeVarsAndConds::String->Tree XMLNode->([(String,String)],[([String],String)],[String])->Int->[Pos]->[Var]->Int->[Pos]
mangeVarsAndConds filter tree cond nesting res vars posNeg
	|posNeg == 1 = result
	|posNeg == 0 = [(0,0,0,0,0,fText)]
	where
	nres = map (adjustRoot) res
	result = manageVariables nres vars tree cond posNeg
	-- lr = length result
	(_,_,_,_,_,nText) = head result
	fText = adjust_attributes (fst (buildNewEmbedd [] nText))

adjustRoot (a,b,c,d,e,tree) = case tree of
	(Tree (ELNode label []) args)
		|(label=="and") || (label=="or") || (label=="xor") -> (a,b,c,d,e,(setLabel tree "1^0"))
		|otherwise -> (a,b,c,d,e,tree)
	(Tree (TXNode label) []) -> (a,b,c,d,e,tree)	
{-
embeddProva t i df = do { path<-readFile "Path.ini";
		 file<-return(head (lines path));
		 content<-readFile file;
		 (index,mapp,tree)<-return(parseText content);
	         if (i==1) then
	         	do {
		         (a,b,c)<-return(manageExtQuery "neg" df index mapp tree 2 t);
		         na<-return(map adjustRoot a);
		         viewThree na b c;
		         }
		  else
		  	do {
		         nText<-return(evalExternalQuery "best" df content ([],[],[]) "N" 1 t);
		         putStrLn (show nText);
		         }
		  }

viewPList [] = putStrLn ("No Embedding founded");
viewPList list = do{
		putStrLn ("New Query Embedding\n");
		mymap view list;
		putStrLn ("");}
viewTree [] = putStrLn("Nada")
viewTree (t:ts) = do {putStrLn(showFormattedXML 0 t);
		      viewTree ts;}
viewList (pos,vars) = do{
		putStrLn ("RESULT:\n");
		mymap view pos;
		putStrLn ("Variables:\n");
		mymap viewM1 vars;
		putStrLn ("\n");}
viewThree list vars b = do {
		putStrLn ("posting:");
		mymap view list;
		putStrLn ("vars:");
		mymap viewM1 vars;
		putStrLn (show b);
		}
		
view (p,_,_,_,c,tree) = putStrLn ("Embedding cost: "++(show c)++"\nEmbedding position: "++(show p)++"\nEmbedding tree:\n"++(show (adjust_attributes tree))++"\n");

file = do {path<-readFile "Path.ini";
	   return(head (lines path))}
-}